s = Server.internal; s.boot;

(
SynthDef(\fabsynth, {
	arg 	freq1 = 200,
			freq2 = 1,
			pan = 0,
			delay_time = 0.2,
			feedback_amount = 0,
			vol = 1;

	var local, osc1, osc2;

	local = LocalIn.ar(2) * feedback_amount;

	osc1 = Pan2.ar(SinOsc.ar(freq1.lag), pan.lag) + local;
	osc2 = SinOsc.ar(freq2.lag, mul: osc1);

	local = DelayC.ar(osc2, 8, delay_time.lag);
	local = local * feedback_amount.lag;

	LocalOut.ar(local.reverse);
	Out.ar(0, (osc2 * vol.lag).sin);

}).add;
)

x = Synth(\fabsynth);
x.free;
x.set(\freq1, 1000);
x.set(\freq2, 100);
x.set(\delay_time, 0.1);
x.set(\feedback_amount, 0);
x.set(\feedback_amount, 0.8);
x.set(\feedback_amount, 1.28);
x.set(\feedback_amount, 1.9);
x.set(\pan, 1);

//

(
MIDIIn.connectAll;

p = SerialPort(
    "/dev/tty.usbserial-AJ02W9I3",    //edit to match your port. SerialPort.listDevices
    baudrate: 9600,    //check that baudrate is the same as in arduino sketch
    crtscts: true);
)

//read 10bit serial data sent from Arduino's Serial.println
(
r= Routine({
    var byte, str, res;
    99999.do{|i|
        if(p.read==10, {
            str = "";
            while({byte = p.read; byte !=13 }, {
                str= str++byte.asAscii;
            });

			res = str.split($ );

			switch (res[0],
				"count:", {
					if (~reset != 1, {
						~feedback = res[1].asFloat.abs * 0.1;
						x.set(\feedback_amount, ~feedback);
						("feedback " + ~feedback).postln;
					});
				},
				"switch:", {
					"reset".postln;
					~feedback = 0;
					if (res[1].asInt == 1, {
						~reset = 1;
					}, {
						~reset = 0;
					});
					x.set(\feedback_amount, ~feedback);
				},{
					str.split($ )[0].postln;
				}
			);
        });
    };
}).play;
)
(
a = MIDIFunc.cc({
	arg ...args;
	var val;

	if (~reset != 1, {
		val = args[0] / 127;

		switch (args[1],
			3, {
				x.set(\vol, args[0]);
			},
			4, {
				if ((args[2] == 0) || (args[2] == 1), {
					if (val > 0.55, {
						val = val.lincurve(0.55, 1, 200, 17000, 4);
					}, {
						if (val < 0.45, {
							val = val.lincurve(0, 0.45, 0, 200, 4);
						}, {
							val = 200;
						});
					});
					switch (args[2],
						0, {
							x.set(\freq1, val);
						},
						1, {
							x.set(\freq2, val);
					});
					val.postln;
				});
				switch(args[2],
					2, {
						x.set(\delay_time, val * 8);
					},
					3, {
						x.set(\pan, (val * 2) - 1);
					}
				);
			}
		);
	});
	args.postln;
});
)
a.free
(
x.free;
a.free;
p.close;
r.stop;
)